<?php 
defined('C5_EXECUTE') or die(_("Access Denied."));

/**
 * Sql info by John Liddiard (aka JohntheFish)
 * www.jlunderwater.co.uk, www.c5magic.co.uk
 * This software is licensed under the terms described in the concrete5.org marketplace.
 * Please find the add-on there for the latest license copy.
 */

class DashboardSystemEnvironmentSqlinfoController extends Controller {

	public function on_start(){
		$this->addHeaderItem($this->some_css());

		$html = Loader::helper('html');
		if(	$this->traditional()){
			$this->addHeaderItem($html->javascript('jquery.kinetic.js', 'jl_sqlinfo'));
		}else{
			$this->addFooterItem($html->javascript('jquery.kinetic.js', 'jl_sqlinfo'));
		}
	}

	public function traditional(){
		if(version_compare(Config::get('SITE_APP_VERSION'), 5.5, 'lt')) {
			$this->set('traditional', true);
			$this->set('fivefive', false);
			return true;
		}
		$this->set('traditional', false);
		$this->set('fivefive', true);
		return false;
	}

	public function fivefive(){
		return ! $this->traditional ();
	}

	public function view() {

		$poss_info_cats = array(
				'VARIABLES'			=>	t('Session Variables'),
				'GLOBAL VARIABLES'	=>	t('Global Variables'),
				'TABLES'			=>	t('Tables'),
				'DATABASES'			=>	t('Databases'),
				'PRIVILEGES'		=>	t('Privileges'),
				'PROCESSLIST'		=>	t('Processlist'),
				'STATUS'			=>	t('Status'),
			);
		$this->set('poss_info_cats',$poss_info_cats);

		// See what button was clicked. Should only be one category
		$info_cats = array();
		foreach ($_POST as $ky=>$val){
			if (preg_match("/ccm\-submit\-/i",$ky)){
				$cat = array_search ($val, $poss_info_cats);
				if ($cat !== false){
					$info_cats[] = $cat;
				}
			}
		}
		if (empty($info_cats)){
			$info_cats[] = 'VARIABLES';
		}

		$this->set('info_cats',$info_cats);

		foreach ($info_cats as $info_cat){
			$categories .= $poss_info_cats[$info_cat].' '; //.'('.$info_cat.') ';
		}
		$this->set('categories',$categories);
	}

	public function enquire ($stuff){
		$db = $db = Loader::db();

		$queries = array (
				'VARIABLES'			=>	'SHOW VARIABLES',
				'GLOBAL VARIABLES'	=>	'SHOW GLOBAL VARIABLES',
				'TABLES'			=>	'SHOW TABLE STATUS',
				'DATABASES'			=>	'SHOW DATABASES',
				'PRIVILEGES'		=>	'SHOW PRIVILEGES',
				'PROCESSLIST'		=>	'SHOW PROCESSLIST',
				'STATUS'			=>	'SHOW STATUS',
		);

		try {
			$info = $db->GetAll($queries[$stuff]);
		}catch (Exception $e){
    		$info[] = array ('SQL Exception', $e->getMessage());
		}

		return $info;
	}

	/**
	 * Some css to pretty up the output format
	 */
	public function some_css (){
		$url = Loader::helper("concrete/urls");
		$hand = $url->getPackageURL(package::getbyhandle('jl_sqlinfo')).'/images/hand.png';

		ob_start();
		?>
		<style type="text/css">
		#sqlinfo_form tr > td:first-child,
		#sqlinfo_form th
			{
			background: #EEE;
		}
		#sqlinfo_form tr>th{
			border-top: 1px solid #ddd;
		}
		#sqlinfo_form tr:first-child>th{
			border-top: none;
		}
		#sqlinfo_form td{
			word-wrap: break-word;
			white-space: pre-wrap;
		}
		#sqlinfo_form table.ccm-results-list tr.ccm-list-record:hover td {
			cursor: auto;
		}

		#sqlinfo_form div.jlkinetic th,
		#sqlinfo_form div.jlkinetic table.ccm-results-list tr.ccm-list-record:hover td {
			cursor:url(<?php  echo $hand;?>),e-resize!important;
		}
		#selectable_text{
			width:100%;
			position: relative;
			display: block;
		}
        #selectable_text pre{
       		padding: 8.5px;
       		border: 1px solid #CCC;
       		line-height: 18px;
			-webkit-border-radius: 3px;
			-moz-border-radius: 3px;
			border-radius: 3px;
        }
		#selectall{
			top: 5px;
			right: 10px;
			position: absolute;
			display: block;
		}
		#copytmp,#copytmp:focus{
			position: absolute;
			top: 0;
			left: 0;
			border: none;
			outline: none;
			resize: none;
			overflow: hidden;
			-webkit-box-shadow: none;
      		-moz-box-shadow: none;
            box-shadow: none
        }
        #sqlinfo_form div.table_wrapper{
        	overflow-x:scroll;
        }

        #sqlinfo_form div.jl-top-footer {
			-webkit-border-radius: 0 0 0 0;
			-moz-border-radius: 0 0 0 0;
			border-radius: 0 0 0 0;
		}
		</style>
		<?php 
		$css = ob_get_contents();
		ob_end_clean();
		return $css;
	}

}